void main()
{
	vec3 Cin					= texture( InputTexture, TexCoord ).rgb ;
	vec3 Cout ;
	
	if( Cin.g <= 0.301 && min( Cin.r, Cin.b ) >= 0.699 )
	{
		Cin.rb					-= 0.7 ;
		Cin						*= 1.0 / 0.3 ;
		
		float ledge				= mix( vertex1.x, vertex2.x, 1.0 - ( TexCoord.y - vertex1.y ) / ( vertex2.y - vertex1.y ));
		float redge				= mix( vertex3.x, vertex4.x, 1.0 - ( TexCoord.y - vertex3.y ) / ( vertex4.y - vertex3.y ));
		
		if( TexCoord.x >= ledge &&
			TexCoord.x <= redge &&
			TexCoord.y >= min( vertex1.y, vertex3.y ) &&
			TexCoord.y <= max( vertex2.y, vertex4.y ))
		{
			float x				= ( TexCoord.x - ledge ) / ( redge - ledge );
			float y				= ( TexCoord.y - vertex1.y ) / ( vertex4.y - vertex1.y );
			vec4 contour		= texture( spectre_frames, vec2( x / 8 + rotpos, ( 1.0 - y ) / 9 + frapos ));
			
			if( contour.a > 0 )
			{	
				ivec2 scrnDims	= textureSize( InputTexture, 0 );
				float angle		= radians( contour.r * 360 );
				float xpos		= TexCoord.x + cos( angle ) * depth ;
				float ypos		= TexCoord.y + sin( angle ) * depth ;
				
				//do this better:
				if		( xpos < 0 ) xpos = TexCoord.x ;//* 0.5 ;
				else if	( xpos > 1 ) xpos = TexCoord.x ;//+ ( 1.0 - TexCoord.x ) * 0.5 ;
				if		( ypos < 0 ) ypos = TexCoord.y ;//* 0.5 ;
				else if	( ypos > 1 ) ypos = TexCoord.y ;//+ ( 1.0 - TexCoord.y ) * 0.5 ;
				
				vec3 C	= texelFetch( InputTexture, ivec2( vec2( xpos, ypos ) * scrnDims ), 0 ).rgb ;
				
				if( C.g <= 0.301 && min( C.r, C.b ) >= 0.699 )
				{
					C.rb		-= 0.7 ;
					C			*= 1.0 / 0.3 ;
				}
				else if( reflect == 0 ) C = Cin ;
				
				Cout			= mix( Cin, C, alpha );
			}
			else Cout			= Cin ;
		}
		else Cout				= Cin ;
	}
	else Cout					= Cin ;
	
	FragColor					= vec4( Cout, 1.0 );
}